/*
 * This Trade abstract class provides all the methods common 
 * for both SellTrade and BuyTrade classes that will inherit 
 * for it.
 */
public class Order {
	private int qty;
	private float price;
	private int time;
	private String type;
	private Customer c;
	private Stock stock;
	
	Order(int time, String type, Customer c, Stock stock, int qty, float price) {
		this.qty = qty;
		this.price = price;
		this.c = c;
		this.time = time;
		this.type = type;
		this.stock = stock;
	}
	
	Order(Order o) {
		this.qty = o.getQty();
		this.price = o.getPrice();
		this.c = o.getCustomer();
		this.time = o.getTime();
		this.type = o.getType();
		this.stock = o.getStock();
	}
	
	int getQty() {	return qty; }
	
	float getPrice() { return price; }
	
	int getTime() { return time;	}
	
	String getType() { return type; }
	
	Customer getCustomer() { return c; }
	
	Stock getStock() { return stock; }
	
	void setQty(int qty) { this.qty = qty; }
	
	@Override
	public int hashCode() {
		// in current implementation, time is assured to 
		// be unique	
		return this.time;
	}

	@Override
	public boolean equals(Object o) {
		// self check
		if (this == o)	return true;
		
		// null check
		if (o == null) return false;
		
		// type check and case
		if (getClass() != o.getClass()) return false;
		
		Order t = (Order) o;
		
		return this.time == t.getTime() && this.type.equals(t.getType())
				&& this.c.equals(t.getCustomer()) && this.stock.equals(t.getStock())
				&& this.qty == t.getQty() && this.price == t.getPrice();
	}

	@Override
	public String toString() {
		return "<" + time + "," + type + "," + c + "," + stock + "," + 
					qty + "," + price + ">";
	}
}
